/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the BillingAccount type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &BillingAccount{}

// BillingAccount struct for BillingAccount
type BillingAccount struct {
	Name string `json:"name"`
	Type *string `json:"type,omitempty"`
	TaxId *string `json:"tax_id,omitempty"`
	ContactInfo *BillingContactInfo `json:"contact_info,omitempty"`
	BillingAddress *ContactAddress `json:"billing_address,omitempty"`
	Id string `json:"id"`
}

// NewBillingAccount instantiates a new BillingAccount object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewBillingAccount(name string, id string) *BillingAccount {
	this := BillingAccount{}
	this.Name = name
	this.Id = id
	return &this
}

// NewBillingAccountWithDefaults instantiates a new BillingAccount object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewBillingAccountWithDefaults() *BillingAccount {
	this := BillingAccount{}
	return &this
}

// GetName returns the Name field value
func (o *BillingAccount) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *BillingAccount) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *BillingAccount) SetName(v string) {
	o.Name = v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *BillingAccount) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingAccount) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *BillingAccount) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *BillingAccount) SetType(v string) {
	o.Type = &v
}

// GetTaxId returns the TaxId field value if set, zero value otherwise.
func (o *BillingAccount) GetTaxId() string {
	if o == nil || IsNil(o.TaxId) {
		var ret string
		return ret
	}
	return *o.TaxId
}

// GetTaxIdOk returns a tuple with the TaxId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingAccount) GetTaxIdOk() (*string, bool) {
	if o == nil || IsNil(o.TaxId) {
		return nil, false
	}
	return o.TaxId, true
}

// HasTaxId returns a boolean if a field has been set.
func (o *BillingAccount) HasTaxId() bool {
	if o != nil && !IsNil(o.TaxId) {
		return true
	}

	return false
}

// SetTaxId gets a reference to the given string and assigns it to the TaxId field.
func (o *BillingAccount) SetTaxId(v string) {
	o.TaxId = &v
}

// GetContactInfo returns the ContactInfo field value if set, zero value otherwise.
func (o *BillingAccount) GetContactInfo() BillingContactInfo {
	if o == nil || IsNil(o.ContactInfo) {
		var ret BillingContactInfo
		return ret
	}
	return *o.ContactInfo
}

// GetContactInfoOk returns a tuple with the ContactInfo field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingAccount) GetContactInfoOk() (*BillingContactInfo, bool) {
	if o == nil || IsNil(o.ContactInfo) {
		return nil, false
	}
	return o.ContactInfo, true
}

// HasContactInfo returns a boolean if a field has been set.
func (o *BillingAccount) HasContactInfo() bool {
	if o != nil && !IsNil(o.ContactInfo) {
		return true
	}

	return false
}

// SetContactInfo gets a reference to the given BillingContactInfo and assigns it to the ContactInfo field.
func (o *BillingAccount) SetContactInfo(v BillingContactInfo) {
	o.ContactInfo = &v
}

// GetBillingAddress returns the BillingAddress field value if set, zero value otherwise.
func (o *BillingAccount) GetBillingAddress() ContactAddress {
	if o == nil || IsNil(o.BillingAddress) {
		var ret ContactAddress
		return ret
	}
	return *o.BillingAddress
}

// GetBillingAddressOk returns a tuple with the BillingAddress field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *BillingAccount) GetBillingAddressOk() (*ContactAddress, bool) {
	if o == nil || IsNil(o.BillingAddress) {
		return nil, false
	}
	return o.BillingAddress, true
}

// HasBillingAddress returns a boolean if a field has been set.
func (o *BillingAccount) HasBillingAddress() bool {
	if o != nil && !IsNil(o.BillingAddress) {
		return true
	}

	return false
}

// SetBillingAddress gets a reference to the given ContactAddress and assigns it to the BillingAddress field.
func (o *BillingAccount) SetBillingAddress(v ContactAddress) {
	o.BillingAddress = &v
}

// GetId returns the Id field value
func (o *BillingAccount) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *BillingAccount) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *BillingAccount) SetId(v string) {
	o.Id = v
}

func (o BillingAccount) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o BillingAccount) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["name"] = o.Name
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	if !IsNil(o.TaxId) {
		toSerialize["tax_id"] = o.TaxId
	}
	if !IsNil(o.ContactInfo) {
		toSerialize["contact_info"] = o.ContactInfo
	}
	if !IsNil(o.BillingAddress) {
		toSerialize["billing_address"] = o.BillingAddress
	}
	toSerialize["id"] = o.Id
	return toSerialize, nil
}

type NullableBillingAccount struct {
	value *BillingAccount
	isSet bool
}

func (v NullableBillingAccount) Get() *BillingAccount {
	return v.value
}

func (v *NullableBillingAccount) Set(val *BillingAccount) {
	v.value = val
	v.isSet = true
}

func (v NullableBillingAccount) IsSet() bool {
	return v.isSet
}

func (v *NullableBillingAccount) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableBillingAccount(val *BillingAccount) *NullableBillingAccount {
	return &NullableBillingAccount{value: val, isSet: true}
}

func (v NullableBillingAccount) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableBillingAccount) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


